EDIT - bug #7105

potential dangerous use of factory.openSession()
12/04/2017 11:10 AM - Andreas Kohlbecker
Category: cdmlib Estimated time: 0:00 hour
Target version: Reviewed Next Major Release
Description

in the cdmlib factory.openSession() is being used in three places.

o dmlib-mode estiav dm/model/Databaselnitialiserjava : this is OK!!!
¢ /cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/application/CdmRepository.java : Problematic!#7106

e /cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/DaoBase.java : Problematic!#8169

the usage of factory.openSession() in CdmRepository and DaoBase seem unnecessary and can potentially be dangerous since
sessions should generally be managed through the HibernateTransactionManger only. factory.openSession() should only be uses in
dedicated special cases, therefore the current implementation of getSession() in these classes seems as a error prone convenience
hack:

In DaoBase and CdmRepository this occures in:

protected Session getSession() {
Session session ;
try {
session = factory.getCurrentSession();
} catch (HibernateException e) {
session = factory.openSession();
}

return session;

In CdmRepository using factory.openSession() is plain wrong, the HibernateTransactionManger should be used instead.

Instead of catching the HibernateException, the method should return null or throw the exception so that the caller needs to handle
this case.

especially the usage in DaoBase is critical since this method is called from many places. Usually this is not a problem as log as the
dao methods are called from a service method which are wrapped in a transactional context:

eu.etaxonomy.cdm.persistence.dao.hibernate.common.DaoBase.getSession ()
eu.etaxonomy.cdm.persistence.dao.hibernate.common.PreferenceDaoImpl.count ()
eu.etaxonomy.cdm.persistence.dao.hibernate.description.IdentificationKeyDaoImpl.count ()
eu.etaxonomy.cdm.persistence.dao.hibernate.view.AuditEventDao.count ()
eu.etaxonomy.cdm.persistence.dao.hibernate.description.IdentificationKeyDaoImpl.countByTaxonomicSc
ope (UUID, Class<T>)
eu.etaxonomy.cdm.persistence.dao.hibernate.statistics.StatisticsDaoHibernateImpl.countNomenclatura
1References ()
eu.etaxonomy.cdm.persistence.dao.hibernate.statistics.StatisticsDaoHibernateImpl.countTaxaInClassi
fication(Class<? extends TaxonBase>, Classification)
eu.etaxonomy.cdm.persistence.dao.hibernate.view.AuditEventDao.exists (UUID)
eu.etaxonomy.cdm.persistence.dao.hibernate.common.PreferenceDaoImpl.find (TaxonNode, String)
eu.etaxonomy.cdm.persistence.dao.hibernate.view.AuditEventDao.findByDate (DateTime)
eu.etaxonomy.cdm.persistence.dao.hibernate.view.AuditEventDao.findById (Integer)
eu.etaxonomy.cdm.persistence.dao.hibernate.description.IdentificationKeyDaoImpl.findByTaxonomicSco
pe (UUID, Class<T>, Integer, Integer, List<String>)
eu.etaxonomy.cdm.persistence.dao.hibernate.view.AuditEventDao.findByUuid (UUID)
eu.etaxonomy.cdm.persistence.dao.hibernate.common.DaoBase.flush ()
eu.etaxonomy.cdm.persistence.dao.hibernate.common.PreferenceDaolmpl.get (PrefKey)
eu.etaxonomy.cdm.persistence.dao.hibernate.statistics.StatisticsDaoHibernateImpl.getAl1ChildNodeId
https://dev.e-taxonomy.eu/redmine/issues/7106
https://dev.e-taxonomy.eu/redmine/issues/8169
hibernate.view.AuditEventDao.getAuditReader ()
hibernate.view.AuditEventDao.getNextAuditEvent (AuditEvent)
.hibernate.view.AuditEventDao.getPreviousAuditEvent (AuditEvent)
hibernate.common.CdmEntityDaoBase.getSession ()
hibernate.common.PreferenceDaoImpl.list ()
hibernate.view.AuditEventDao.list (Integer, Integer, AuditEventSor

.hibernate.description.IdentificationKeyDaoImpl.list (Integer, Inte

ger, List<String>)

eu.etaxonomy.cdm.persistence.dao.hibernate.statistics.StatisticsDaoHibernateImpl.processQueries (Li

st<String>, Map<String, Object>)

eu.etaxonomy.cdm.persistence.dao.hibernate.statistics.StatisticsDaoHibernateImpl.processQueriesWit

hIdDistinctListResult (List<String>, Map<String, Object>)
eu.etaxonomy.cdm.persistence.dao.hibernate.common.PreferenceDaoImpl.set (CdmPreference)

Subtasks:
bug # 7106: avoid factory.openSession() in CdmRepository
bug # 8169: avoid factory.openSession() in DaoBase

Closed
New

Associated revisions

Revision 71cf0ed1 - 12/18/2017 11:56 AM - Andreas Kohlbecker

ref #7105 logging the calls to factory.openSession() as error

History

#1 - 12/04/2017 11:16 AM - Andreas Kohlbecker

- Description updated

#2 - 12/04/2017 11:17 AM - Andreas Kohlbecker

- Description updated

#3 - 12/18/2017 11:52 AM - Andreas Kohlbecker

- Description updated

#4 - 02/02/2018 03:32 PM - Andreas Miiller

- Target version changed from Unassigned CDM tickets to Release 4.14

#5 - 02/02/2018 03:34 PM - Andreas Miller

Strange, | can't change priority in this ticket. AK, can you change it to highest?

#6 - 02/15/2018 03:16 PM - Andreas Miller

- Target version changed from Release 4.14 to Release 5.0

#7 - 05/14/2018 11:30 PM - Andreas Miiller

- Target version changed from Release 5.0 to Release 5.1

#8 - 06/27/2018 02:27 PM - Andreas Miuller

- Target version changed from Release 5.1 to Release 5.2

#9 - 08/17/2018 03:44 PM - Andreas Miuller

- Target version changed from Release 5.2 to Release 5.3

#10 - 09/06/2018 09:57 AM - Andreas Miiller

- Target version changed from Release 5.3 to Release 5.4

#11 - 10/23/2018 11:29 AM - Andreas Miller

- Target version changed from Release 5.4 to Release 5.5

#12 - 02/14/2019 10:24 PM - Andreas Miiller
- Target version changed from Release 5.5 to Release 5.6

#13 - 02/19/2019 05:01 PM - Andreas Miiller

- Target version changed from Release 5.6 to Reviewed Next Major Release

#14 - 03/07/2019 03:28 PM - Andreas Kohlbecker

- Description updated
